unit Utils;

interface

uses Winprocs,Wintypes,Sysutils,Commdlg;

function CopyFile(Source,Dest: String): Bool;
procedure YieldApp;
function StringValidate(Instr: String):Bool;
function Semivalidate(Instr: String):Bool;

implementation

procedure YieldApp;
var MSG: TMsg;
	Handle: THandle;
	(*Note: nil below is handle to help window*)
begin
	Handle := 0;
	while PeekMessage(Msg,Handle, 0, 0, PM_REMOVE) = True
		do if(Msg.message = 18)
	{WM_QUIT or 0x0012 is not accepted as an identifier...clear enough.
	C version is if(Message.message == WM_QUIT)...trying 18 as the value}
			then begin
				PostQuitMessage(0);
				end
			else begin
				TranslateMessage(Msg);
				DispatchMessage(Msg);
	end;
end;

function CopyFile(Source,Dest: String): Bool;
var	FromF, ToF: file;
	NumRead, NumWritten: Word;
	Buf: array[1..2048] of Char;
	P1,P2: array [0..255] of char;
	FileReady,Copied: boolean;
	Curdir,S1:String;
begin
	Getdir(0,Curdir);
	Copied := False;
	FileReady := False;
{See if source file exists before doing anything}
	If (FileExists(Source) = True) then FileReady := True else begin
		StrPCopy(P2,'File ' + Source + 'not found in the specified location.');
		MessageBox(GetActiveWindow,P2,'File copy error',48);
	end;
	If Source = Dest then FileReady := False;
	If (FileReady = True) Then begin
		AssignFile(FromF, Source);
		Reset(FromF, 1);
		AssignFile(ToF, Dest);
		Rewrite(ToF, 1);
		repeat
			BlockRead(FromF, Buf, SizeOf(Buf), NumRead);
			BlockWrite(ToF, Buf, NumRead, NumWritten);
			Copied := True;
		until (NumRead = 0) or (NumWritten <> NumRead);
		CloseFile(FromF);
		CloseFile(ToF);
    If FileExists(Dest) Then Copyfile := True else Copyfile := False;
	end;
	ChDir(Curdir);
end;


function Semivalidate(Instr: String):Bool;
var Errchar:String;
begin
	Result := True;
	If Pos(';',Instr) <> 0 Then begin
		Result := False;
		MessageBox(GetActiveWindow,
			'Semicolons are not always legal in this application. '
			+'Colons ('':'') are legal both in parameter strings and as '
			+'macro delimiters. Semicolons are unreliable delimiters and '
			+'illegal in parameter strings. '
			+'Change or remove semicolons for improved reliability.'
			,'Semicolon detected in entry string',48);
	end;
	If Pos('"',Instr) <> 0 Then begin
		Result := False;
		MessageBox(GetActiveWindow,
			+'A double-quote has been detected in your macro. Since this is '
			+'probably a nested macro, you should change double-quote syntax '
			+'to "` ''" style single quotes. Double-quote syntax is '
			+'invalid in nested macros. Single quotes are always acceptable.'
			,'Double-quote detected in macro string',48);
	end;
end;

function StringValidate(Instr: String):Bool;
var Errchar:String;
	P1: array [byte] of Char;
begin
	Result := True;
	If Pos(';',Instr) <> 0 Then begin
		Errchar := ' (semicolon).';
		Result := False;
	end;
	If Pos('`',Instr) <> 0 Then begin
		Errchar := ' (left quote).';
		Result := False;
	end;
	If Pos('\',Instr) <> 0 Then begin
		Errchar := ' (backslash).';
		Result := False;
	end;
	If Pos('"',Instr) <> 0 Then begin
		Errchar := ' (double quote).';
		Result := False;
	end;
	If Pos(#39,Instr) <> 0 Then begin
		Errchar := ' (single quote).';
		Result := False;
	end;
	If Result = False then begin
		StrPCopy(P1,'Unable to use this parameter. The string you are typing or just '
			+'pasted contains an illegal character' + Errchar +#10
			+'Edit the parameter string and try again.');
		MessageBox(GetActiveWindow,P1,'Illegal character in parameter string',48);
	end;
end;


end.
